Subject: Re: linux-next: add utrace tree

From: Oleg Nesterov <[email-masked]>
Date: Wed, 27 Jan 2010 00:32:42 +0100

On 01/26, Andi Kleen wrote:
>
> > Simple example. Try to debug/strace strace ot gdb itself. Not trivial,
> > you can't attach to strace's tracees. Recently I spent 2 days trying to
> > understand why strace -f hangs. I was able to attach to strace, but
> > I wasn't able to see what its tracees do.
>
> But what would the semantics be inside the tracees even if you could?

In this particular case, all I need was something like "gdb -p" to
attach to the tracee, see the backtrace and detach.

> > And, it was not possible to even trace strace until it hangs, with
> > ptrace the tracee (strace) must stop to report the event and this
> > shadowed the race.
>
> "Shadowing the race" was the second surname of strace I thought anyways @)
> Basically if you care about races never use strace in the first place.

Yes. And utrace doesn't require the tracee to be stopped to report the
event ;) Yes, yes, utrace can't "fix" strace in this sense automatically,
but still.

Oleg.